package com.hellokoding.jpa.model;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Entity
public class Book{

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;
    private String name;

//    @ManyToMany()//fetch = FetchType.EAGER)
//    @JoinTable(name = "book_publisher",
//               joinColumns = @JoinColumn(name = "book_id", referencedColumnName = "id"),
//               inverseJoinColumns = @JoinColumn(name = "publisher_id", referencedColumnName = "id"))

    @OneToMany(mappedBy = "book", fetch = FetchType.EAGER)
    private List<BookPublisher> bookPublisherList = new ArrayList<>();

    public Book() {
    }

    public Book(String name) {
        this.name = name;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<BookPublisher> getBookPublisherList() {
        return bookPublisherList;
    }

    public void setBookPublisherList(List<BookPublisher> bookPublisherList) {
        this.bookPublisherList = bookPublisherList;
    }

    public List<Publisher> getPublishers(){
        List<Publisher> publisherList = new ArrayList<>();
        for(BookPublisher bookPublisher : this.bookPublisherList){
            Publisher publisher = bookPublisher.getPublisher();
            publisherList.add(publisher);
        }

        return  publisherList;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        Book book = (Book) o;

        if (getId() != book.getId()) return false;
        return getName().equals(book.getName());

    }

    @Override
    public int hashCode() {
        int result = getId();
        result = 31 * result + getName().hashCode();
        return result;
    }

    @Override
    public String toString() {
        return this.getName();
    }
}
